/*
 ******************************************************************************
 *
 * @file     adc.h
 * @brief    adc module
 *                 
 *
 * @version  1.0
 * @date     2023/05/12   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2023/07/12      Alex          build this file
 ******************************************************************************
 */

#ifndef __ADC_H__
#define __ADC_H__
/*_____ I N C L U D E S ____________________________________________________*/

#include "define.h"

#if ADC_ENABLE
/******************************************************************************\
                          Macro definitions
\******************************************************************************/

#define VREF	1000

/******************************************************************************\
                             Variables definitions
\******************************************************************************/
extern idata uint16_t Vbat_Adc;

typedef enum {
	ADC_CH0 = 0x00,
	ADC_CH1,	
	ADC_CH2,
	ADC_CH3,
	ADC_CH4,
	ADC_BAT,
	ADC_VREF,
}ADC_CHANNELS_E;
	
/******************************************************************************\			 
							 Functions definitions
\******************************************************************************/
extern uint16_t Vbat_Value(void);

extern uint16_t ADC_NTC_Value(void);


#endif

#endif

