/*
 ******************************************************************************
 *
 * @file     gpio_comm.h
 * @brief    gpio_comm module
 *                 
 *
 * @version  1.0
 * @date     2024/07/18   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2024/07/18      Alex          build this file
 ******************************************************************************
 */

#ifndef __GPIO_COMM_H__
#define __GPIO_COMM_H__

/*_____ I N C L U D E S ____________________________________________________*/

#include "define.h"

#if VOX_TX_PATTERN

/******************************************************************************\
                          Macro definitions
\******************************************************************************/
sbit PATTERN_TX = P0^1; 			

#define PATTERN_TX_ON()			COM_CTRL = 1
#define PATTERN_TX_OFF()		COM_CTRL = 0


/******************************************************************************\
                             Variables definitions
\******************************************************************************/

extern bit	Pattern_TX_Start;

extern uint16_t	Pattern_TX_Data;

typedef enum {
	GPIO_TX_STEPS_NONE = 0,
	GPIO_TX_STEPS_START,
	GPIO_TX_STEPS_BIT_SYC,
	GPIO_TX_STEPS_DATA,
	GPIO_TX_STEPS_STOP,
}e_Gpio_Comm_Step;


/******************************************************************************\
							 Functions definitions
\******************************************************************************/
extern void Gpio_Comm(uint16_t Data);


#endif



#endif

