/*
 ******************************************************************************
 *
 * @file     hall.h
 * @brief    hall module
 *                 
 *
 * @version  1.0
 * @date     2023/05/12   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2023/07/12      Alex          build this file
 ******************************************************************************
 */

#ifndef __HALL_H__
#define __HALL_H__

/*_____ I N C L U D E S ____________________________________________________*/

#include "define.h"

/******************************************************************************\
                          Macro definitions
\******************************************************************************/

/******************************************************************************\
                             Variables definitions
\******************************************************************************/

typedef enum{

	CLOSE = 0, 
	OPEN = !CLOSE

} CoverStatus_E;
	
extern CoverStatus_E CoverStatus;

extern bit CoverEvent_Flg;
extern bit CoverEvent_Flg_led;
extern uint8_t Hall_Sta_bk;

#if HALL_ENABLE

/******************************************************************************\
                             Functions definitions
\******************************************************************************/

//extern void Hall_Init(void);
extern  void Hall_Handler(void);

#endif

#endif

