/*
 ******************************************************************************
 *
 * @file     Config.h
 * @brief    Config module
 *                 
 *
 * @version  1.0
 * @date     2023/07/12   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2023/07/12      Alex          build this file
 ******************************************************************************
 */
#ifndef	__CONFIG_H__
#define	__CONFIG_H__

#include "define.h"


/******************************************************************************\
						  Macro definitions
\******************************************************************************/
/*Charger Module Config Para Setting*/

#define BAT_CV 4200					//CVѹã4.20V
#define BAT_PRE 3000				//ѹ3.0v 
#define BAT_RECHARG 	4075  		//ظѹ4200mv - 135mv = 4075mv


#define CHG_CURRENT_400MA 		0x05

/*20uA Դ½ 104K NTC 貢һ82Kõĵѹֵ*/
#define T_N20C	   1530			//-20(76.5K * 20uA) NTC:1151K		

#define T_N15C	   1495			//-15 ¶

#define T_N10C	   1440			//-10(72K * 20uA) NTC:629K

#define T_0C	   1334				//0(66.7K * 20uA) NTC:357K

#define T_3C	   1300

#define T_8C	   1200	

#define T_10C	   1178				//10(58.9K * 20uA)	NTC:209.7K

#define T_12C	   1100

#define T_15C	   1050

#define T_18C	   996

#define T_42C	   580	

#define T_45C	   546				//45(27.3K * 20uA)	NTC:40.9K

#define T_47C	   500	

#define T_57C	   370	

#define T_60C	   350				//60(17.5K * 20uA)	NTC:22.2K

#define T_75C	   250

#define T_80C	   188				//80(9.4K * 20uA)	NTC:10.6K

/*Boost Module Config Para Setting*/
#define OPEN_BOOST_VIN 3600					//Boost uvloVIN£Boostٴλָĵѹ3.6V
#define OPEN_BOOST_NOVIN 3300				//Boost uvloVIN£Boostٴλָĵѹ3.3V

/*KEY And Hall Module Setting*/
#define HALL_OPEN_LEV_SET		1		//ǸߵƽΪǻǵ͵ƽΪǡ1:ߵƽΪǣ0:͵ƽΪ

/*Sleep Module Setting*/
/*Enter Sleep Time Debounce*/
#define ENTER_STANDBYMODE_CNT	10			//Standby Mode ӳʱ䣬λ

/******************************************************************************\
							 Variables definitions
\******************************************************************************/

/******************************************************************************\
							 UserCfg.Functions definitions
\******************************************************************************/


#endif

