/*
 ******************************************************************************
 *
 * @file     system.h
 * @brief    system module
 *                 
 *
 * @version  1.0
 * @date     2023/05/12   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2023/07/12      Alex          build this file
 ******************************************************************************
 */

#ifndef __SYSTEM_H__
#define __SYSTEM_H__

/*_____ I N C L U D E S ____________________________________________________*/

#include "define.h"

/******************************************************************************\
                          Macro definitions
\******************************************************************************/
	/*жϺż㷽ʽж = жϺ * 8 + 3*/
#define Interrupt_Vector_IE0          0  //0x03,TP3310 IE0 use for wakeup
#define Interrupt_Vector_TF0          1  //0x0B,Timer 0 Overflow
#define Interrupt_Vector_TF1          3  //0x1B,Timer 1 Overflow
#define Interrupt_Vector_RI_TI        4  //0x23,Serial Port0 Interrupt
#define Interrupt_Vector_IE7          8  //0x43,Charger Interrupt
#define Interrupt_Vector_IE2          9  //0x4B,External Interrupr 2/VOX Interrupt
#define Interrupt_Vector_IE3          10 //0x53,External Interrupr 3/ϵͳ쳣жϡԴж
#define Interrupt_Vector_IE4          11 //0x5B,External Interrupr 4/keyHallж
#define Interrupt_Vector_IE5          12 //0x63,NA
#define Interrupt_Vector_IE6          13 //0x6B,ADCж

/******************************************************************************\
                             Variables definitions
\******************************************************************************/



/******************************************************************************\
							 Functions definitions
\******************************************************************************/

extern void System_Init(void);

#endif

