/*
 ******************************************************************************
 *
 * @file     VOX_Module.h
 * @brief    VOL/R module
 *                 
 *
 * @version  1.0
 * @date     2022/07/18   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/07/18      Alex          build this file
 ******************************************************************************
 */
#ifndef __VOX_MODULE_H__
#define __VOX_MODULE_H__

/*_____ I N C L U D E S ____________________________________________________*/

#include "define.h"

extern bit Vox_Vout_Enable;

sbit COM_CTRL = P0^2;

extern uint8_t Vox_TX_Timer;		//VOXָʱ,Hall_Handler0.
extern bit Earphone_Chg_Flag; 					 //б־λ

#if VOX_ENABLE
/******************************************************************************\
						  Macro definitions
\******************************************************************************/
/*
VOXλãϵͳʼ(Vox_init())ͨVOX_CON0

SFRADDR = VOX_CON0;    //VOX500mAʶ2.5uA
SFRDATA &= 0xE0;
SFRDATA |= (VOX_IOUT_500MA << 3) | VOX_ADT_Cur_2_5UA;

*/
#define VOX_IOUT_200MA	0x00				
#define VOX_IOUT_300MA	0x01
#define VOX_IOUT_400MA	0x02
#define VOX_IOUT_500MA	0x03

#define	VOX_ADT_Cur_0_5UA	0x00
#define	VOX_ADT_Cur_1_5UA	0x01
#define	VOX_ADT_Cur_2_5UA	0x02
#define	VOX_ADT_Cur_3_5UA	0x03
#define	VOX_ADT_Cur_4_5UA	0x04
#define	VOX_ADT_Cur_5_5UA	0x05
#define	VOX_ADT_Cur_6_5UA	0x06
#define	VOX_ADT_Cur_7_5UA	0x07

#define HEADER	0x55AA			//VOXͨѶݰͷ

#define BOX_FAC_HEADER	0xFB04			//VOXͨѶ->λݰͷ
#define BESHEADER	0xA5			//VOXͨѶ->ݰͷ

#define TIM_SHUTDOWN_DEBOUNCE		600			//ػǰdebounceʱ

 /******************************************************************************\
							  Variables definitions
 \******************************************************************************/
/*ͨѡ*/
 typedef enum {
	 VOL_CHAN = 0,
	 VOR_CHAN,
	 VOX_BOTH,
 }e_Vox_Chan;

#if 1
 /*״̬*/
  typedef enum {
	  VOX_PAIR_NONE = 0,		//Ч
	  VOX_PAIR_ING,				//
	  VOX_PAIR_OK,				//
	  VOX_PAIR_KEEP,			//ֵǰ״̬
  }e_Vox_Pairing_State;

  /*Լ¼*/
  typedef enum {
	  VOX_PAIRED_NONE = 0,		//Թ
	  VOX_PAIRED_OK,			//Լ¼
  }e_Vox_Paired_State;
#endif	  
 /*ͳֽ˫ͨѶЭID*/
 typedef enum _VOX_FAC_COMMAND_E
 {
	 CMD_FAC_START = 0xB0,			 //⿪ʼָ
	 CMD_FAC_HALL = 0xB1,			 //Hallָ
	 CMD_FAC_GUAGE = 0xB2,			 //ܿ
	 CMD_FAC_LED   = 0xB3,		 	//LEDָ
	 CMD_FAC_SHUTDOWN   = 0xB4,		 	//ػģʽ
	 CMD_FAC_GET_DAUGE   = 0xB5,		 	//ȡָ
	 CMD_FAC_GET_NTC   = 0xB6,		 	//ȡNTCָ
	 CMD_FAC_GET_FWVER   = 0xB7,		 	//ȡ̼汾ָ
	 CMD_FAC_SET_VOX_5V   = 0xB8,		 	//н5Vѹ
 
 }VOX_FAC_COMMAND_E;

/* VOL Enable Type */
typedef enum {

     VOX_VOUT_Mode = 0x00,						//VOx 5V ʹ
     VOX_ADT_Mode,						//VOx ؽ롢ʶʹܣԶʶ
     
} VOX_Enable_Mode_e;

extern bit Cover_Open_Flag;

 /******************************************************************************\
							  UserCfg.Functions definitions
 \******************************************************************************/
extern void Vox_TX_Machine(void);
 
extern void Vox_Det_Machine(void);

#endif

#endif

