/*
 ******************************************************************************
 *
 * @file     discharge_module.c
 * @brief    discharge module
 *                 
 *
 * @version  1.0
 * @date     2022/07/12   17:35:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/07/12      Alex          build this file
 ******************************************************************************
 */
#include "discharge_module.h"
#include "vox_module.h"
#include "adc.h"
#include "charger_module.h"
#include "sys_tim.h"
#include "system.h"
#include "led.h"
#include "bat.h"

bit gBoost_Prepared_Flag = 0;	//Boost㿪

#if DISCHARGE_ENABLE
/******************************************************************************\
                          Macro definitions
\******************************************************************************/

/******************************************************************************\
                             Variables definitions
\******************************************************************************/



bit gBoost_UVLO_Flag = 0;

/******************************************************************************\
                             Functions definitions
\******************************************************************************/

#if 0
/*
*******************************************************************************
*             void DisCharge_Boost_Open(void)
*
* Description : Boost Open 
*				VIN ʱBoost ڵصѹ UVLOӲر 2.8/3.0VӲ boost ʹܡ
*				ʵ֣ VIN3.6V VIN3.3V͵شڵ²ܿ
*
* Arguments   : NONE

* Returns     : NONE

* Notes       : NONE
*
*******************************************************************************
*/
 void DisCharge_Boost_Open(void)
{
	if( gBoost_Prepared_Flag )		//Boost㿪
	{
		BST_EN = 1; 		//Boost Enable쳣ʱӲرա	
	
#ifdef _DEBUG_DISCHARGE
	printf("Bst Open\r\n");
#endif		
	}
}

/*
*******************************************************************************
*			 void DisCharge_Boost_Close(void)
*
* Description : Boost CloseҪǳ쳣ʱӲرգڵLOW״̬£ǷҪرboost
*
* Arguments :

* Returns	 :

* Notes	 :
*
*******************************************************************************
*/
 void DisCharge_Boost_Close(void)
 {
 	if( (BST_EN & 0x01) && gBoost_Prepared_Flag )
 	{
		 BST_EN = 0;	  //Boost Disable	
		 gBoost_Prepared_Flag = 0;
		 
#ifdef _DEBUG_DISCHARGE
	printf("Bst Close\r\n");
#endif		 
 	}	
 }
#endif 
/*
*******************************************************************************
*			 void DisCharge_Handler(void)
*
* Description : Boostŵıܰ· UVLO ŵ±
*
* Arguments	 :

* Returns	 :

* Notes		 :
*
*******************************************************************************
*/

void DisCharge_Handler(void)
{	
	/*ŵ --- Ӳʵ*/
#if 0
	gBoost_Prepared_Flag = 1;
#else
	/*± --- Ӳʵ*/	
	if( CHIP_STA3 & 0x02 )
	{
		gBoost_Prepared_Flag = 0; 
		return;
	}
	
	/*Boost Input UVLO Ӳʵ*/
	if( (CHIP_STA0 & 0x80) )    //־λ
	{
		gBoost_Prepared_Flag = 0; 
		gBoost_UVLO_Flag = 1;
		return;
	}

	/*· (ʹжϱ־λBoost·жϷ棬Ҫд1㡣)-- ·һֱûߴBOOST_HICCUP_TIM֮disable boostʱ 250msʵ֣*/
	if( IRQ_FLAG0 & 0x01 )
	{		
#ifdef _DEBUG_DISCHARGE
	printf("Boost Pro Output Short!\r\n");
#endif	
		gBoost_Prepared_Flag = 0; 

		//һֱ
		if( F_sys_tim_250ms )
		{
			F_sys_tim_250ms = 0;
			IRQ_FLAG0 = 0x01;
			
			BST_EN = 1; 					//250msʱһBoost
		}
		return;
	}	
	
#if NTC_ENABLE	
	/*NTC Handle*/	 				//ʹBoostǰȼNTC¶ȣ쳣Ͳŵ硣
	if( PMU_NTC_Control() )						//NTCŵ硣
	{		
		gBoost_Prepared_Flag = 0; 
		BST_EN = 0; 
		return;
	}	
#endif	
#if 0
	/*ص͵籣*/
	if( F_batlevel_protect )
	{
		gBoost_Prepared_Flag = 0; 
		BST_EN = 0; 
		return;		
	}
#endif	
	gBoost_Prepared_Flag = 1;

#if ADC_ENABLE
	/* 
	VIN ʱBoost ڵصѹ UVLOӲر 2.8/3.0VӲ boost ʹܡ
	ʵ֣ VIN3.6V VIN3.3V͵شڵ²ܿ 
	ֻ VIN3.6Vboost VIN3.3Vboost߼
	ֻעVINʱUVLOָBoostVINӲ
	*/	
	if ( gBoost_UVLO_Flag )
	{
		if( CHIP_STA4 & 0x80 )					//Power GOOD
		{
			if( Vbat_Adc >= OPEN_BOOST_VIN )
			{			
				gBoost_Prepared_Flag = 1;
				gBoost_UVLO_Flag = 0;
			}
			else
			{
				BST_EN = 0; 					//Boost Disable 
				gBoost_Prepared_Flag = 0;
			}
		}
	}

#endif
#endif
}

#endif

