/*
 ******************************************************************************
 *
 * @file     VOX_Module.c
 * @brief    VOL/R module
 *                 
 *
 * @version  1.0
 * @date     2022/07/18   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/07/18      Alex          build this file
 ******************************************************************************
 */
#include "gpio_comm.h"
#include "vox_module.h"

#if VOX_TX_PATTERN
/******************************************************************************\
                          Macro definitions
\******************************************************************************/


/******************************************************************************\
                             Variables definitions
\******************************************************************************/
uint8_t Gpio_TX_Comm_Cnt = 0;
uint8_t Gpio_TX_Steps = GPIO_TX_STEPS_START;

uint8_t Bit_Cnt = 16;
uint8_t Pin_Status = 0;

#define START_LOW_TIM	10
#define START_HIGH_TIM	1


uint16_t Pattern_TX_Data = 0;		//ҪͨVOX͵ݣ8λӵ8λ汾

bit	Pattern_TX_Start = 0;

/******************************************************************************\
                             Functions definitions
\******************************************************************************/
/*
*******************************************************************************
* 			void Gpio_Comm(uint8_t data)
*
* Description : gpio TX Communicate 1ms

* Arguments	: uint8_t data

* Returns 	:

* Notes		:
*
*******************************************************************************
*/
void Gpio_Comm(uint16_t Data)
{
	/*ʼ֡10ms͵ƽ + 1msߵƽ + 10ms͵ƽ*/
	if( Pattern_TX_Start )
	{
		Gpio_TX_Comm_Cnt++;

		if( Gpio_TX_Steps == GPIO_TX_STEPS_START )
		{		
			if( Gpio_TX_Comm_Cnt <= START_LOW_TIM )
			{
				PATTERN_TX_OFF();
			}
			else
			if( Gpio_TX_Comm_Cnt <= (START_LOW_TIM + START_HIGH_TIM) )
			{
				PATTERN_TX_ON();
			}
			else
			if( Gpio_TX_Comm_Cnt <= 22 )	
			{
				PATTERN_TX_OFF();
				if( Gpio_TX_Comm_Cnt == 22 )
				{
					Gpio_TX_Steps = GPIO_TX_STEPS_BIT_SYC;	
				}
			}
		}
		
		if( Gpio_TX_Steps == GPIO_TX_STEPS_BIT_SYC )	 
		{
			Bit_Cnt--;
			if(Bit_Cnt > 15)
			{
				Bit_Cnt = 16;
				Gpio_TX_Steps = GPIO_TX_STEPS_STOP;
			}
			else
			{
				Gpio_TX_Steps = GPIO_TX_STEPS_DATA;
			}
			Pin_Status = (Data>>Bit_Cnt)&0x01;
			Gpio_TX_Comm_Cnt = 0;
		}
		
		if( Gpio_TX_Steps == GPIO_TX_STEPS_DATA )
		{
			if( Pin_Status )	//bit high
			{
				if( Gpio_TX_Comm_Cnt <= 2 )
				{
					PATTERN_TX_ON();
				}
				else
				if( Gpio_TX_Comm_Cnt <= 3 )
				{
					PATTERN_TX_OFF();
					Gpio_TX_Steps = GPIO_TX_STEPS_BIT_SYC;
				}
			}
			else				//bit low
			{
				if( Gpio_TX_Comm_Cnt < 1 )
				{
					PATTERN_TX_ON();
				}
				else
				if( Gpio_TX_Comm_Cnt <= 1 )
				{
					PATTERN_TX_OFF();
					Gpio_TX_Steps = GPIO_TX_STEPS_BIT_SYC;
				}
			}
		}
		else
		if( Gpio_TX_Steps == GPIO_TX_STEPS_STOP )			//stop֡
		{
			if( Gpio_TX_Comm_Cnt < START_LOW_TIM )
			{
				PATTERN_TX_OFF();
				BST_EN = 0;
				VOX_CTL0 &= ~0x30;		//VOXMOS
			}
			else
			{
			//	PATTERN_TX_ON();
				PATTERN_TX = ON;
				Gpio_TX_Comm_Cnt = 0;
				Pattern_TX_Start = 0;
				Gpio_TX_Steps = GPIO_TX_STEPS_START;				
			}
		}
	}
}



#endif

