/*
 ******************************************************************************
 *
 * @file     hall.c
 * @brief    hall module
 *                 
 *
 * @version  1.0
 * @date     2022/08/04   15:00:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/08/04      Alex          build this file
 ******************************************************************************/
 /*_____ I N C L U D E S ____________________________________________________*/
#include "hall.h"
#include "key.h"
#include "led.h"
#include "vox_module.h"
#include "userapp.h"
#include "charger_module.h"
#include "sleep.h"


/******************************************************************************\
                          Macro definitions
\******************************************************************************/

/******************************************************************************\
                             Variables definitions
\******************************************************************************/

CoverStatus_E CoverStatus;

bit CoverEvent_Flg = 0; //Hallش¼־λ
bit CoverEvent_Flg_led = 0; 

#if HALL_ENABLE

uint8_t Hall_Sta_bk = 0xff;

/******************************************************************************\
                             Functions definitions
\******************************************************************************/


/*
 *******************************************************************************
 *             void Hall_Handle(void)
 *
 * Description : Hall Handle --- ѭеã10msCoverStatus --- ָ״̬
 *
 * Arguments   : NONE

 * Returns     : NONE

 * Notes       : NONE
 *
 *******************************************************************************
 */
 
 void Hall_Handler(void)
 {
 	uint8_t Hall_Sta = 0;

	Hall_Sta = CHIP_STA0 & 0x08;
	
	if( Hall_Sta != Hall_Sta_bk)
	{
		if(CHIP_STA0 & 0x08)     //Hall ߵƽ
		{
#if HALL_OPEN_LEV_SET	
			CoverStatus = OPEN;
#else
			CoverStatus = CLOSE;
#endif		
		}
		else
		{
#if HALL_OPEN_LEV_SET	
			CoverStatus = CLOSE;
#else
			CoverStatus = OPEN;		
#endif	
		}
		
		CoverEvent_Flg = 1;
		CoverEvent_Flg_led = 1;
		LED_On_Timer = 0;
		Vox_TX_Timer = 0;
		LED_On_Flag = 1;
		Hall_Sta_bk = Hall_Sta;
#if SLEEP_ENABLE		
		
		Enter_Sleep_Cnt_Restart_Flag = 1;
		
#endif

	}
 }
 
 #endif
 
