/*
 ******************************************************************************
 *
 * @file     key.c
 * @brief    key module
 *                 
 *
 * @version  1.0
 * @date     2022/08/04   15:00:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/08/04      Alex          build this file
 ******************************************************************************/
 /*_____ I N C L U D E S ____________________________________________________*/
#include "key.h"
#include "system.h"
#include "led.h"
#include "sleep.h"
#include "adc.h"
#include "bat.h"
#include "vox_module.h"
#include "userapp.h"

#if KEY_ENABLE
/******************************************************************************\
                          Macro definitions
\******************************************************************************/
#define KEY_PRESS_CNT		50			//¼5s
/******************************************************************************\
                             Variables definitions
\******************************************************************************/

bit Key_Press_short_irq = 0;
bit Key_Press_l_irq = 0;
bit Key_Press_ll_irq = 0;
bit Key_Press_ll_irq1 = 0;

bit Key_l_Flag = 0;

idata KEY_EVENT_E Event_key = 0;

idata uint8_t Key_Press_Debounce = 0;

/******************************************************************************\
                             Functions definitions
\******************************************************************************/

/*
 *******************************************************************************
 *             void Key_Handler(void)
 *
 * Description : Key Handler --- ѭеã5msг(ʱ2s)Ҫж̧Ŵ
 					CoverStatus --- ָ״̬ṩӦKey¼־λӦô
 *
 * Arguments   : NONE

 * Returns     : NONE

 * Notes       : NONE
 *
 *******************************************************************************
 */

 void Key_Handler(void)
 {
#if 1

#if 0

	if( IRQ_FLAG7 )								//а
	{
		if( IRQ_FLAG7 & 0x40 )					//key super long press for 8s interrupt flag
		{
			Key_Press_ll_irq = 1;
			Event_key = KEY_EVENT_LL_8S;
		}
		IRQ_FLAG7 = 0xFF;						//Clear Key Interrupt Flag
	}
	
#else

	if( !(CHIP_STA0 & 0x02) )        //CHIP_STA0 bit1ΪKey״ֵ̬0£
	{
		Key_Press_Debounce++;
		if( Key_Press_Debounce >= KEY_PRESS_CNT )
		{
			if( (CHIP_STA0 & 0x02) == 0 )
			{
				Key_Press_ll_irq = 1;
				Key_Press_ll_irq1 = 1;
				Event_key = KEY_EVENT_LL_8S;
				Key_Press_Debounce = 0;
				LED_On_Flag = 1;
			}
		}
#if SLEEP_ENABLE		
		
		Enter_Sleep_Cnt_Restart_Flag = 1;
		
#endif

	}
	else
	{
		Key_Press_Debounce = 0;
	}
	
#endif	
	
#else

 
	if( Key_l_Flag )
	{
		Key_Press_l_irq = 0;
		Key_l_Flag = 0;
		/*todo*/
		Event_key = KEY_EVENT_L_2S;
		/**/

#ifdef _DEBUG_KEY		
		printf("long press\r\n");
#endif
	}

	if( Key_Press_ll_irq )
	{
		Key_Press_ll_irq = 0;
		/*todo*/
		Event_key = KEY_EVENT_LL_8S;
		
#ifdef _DEBUG_KEY
		printf("supper long press\r\n");
#endif
	}	

	if( Key_Press_short_irq )
	{
		Key_Press_short_irq = 0;
		/*todo*/
		Event_key = KEY_EVENT_SHORT;

#ifdef _DEBUG_KEY
		printf("short press\r\n");
#endif

	}	

#endif
 }

 #endif
