/*
 ******************************************************************************
 *
 * @file     led.c
 * @brief    led module
 * @ic		 TP3102                
 *
 * @version  1.0
 * @date     2022/08/04   15:00:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/08/04      Alex          build this file
 ******************************************************************************/
 /*_____ I N C L U D E S ____________________________________________________*/

#include "led.h"


#ifdef LED_DISPLAY

/******************************************************************************\
                          Macro definitions
\******************************************************************************/

/******************************************************************************\
                             Variables definitions
\******************************************************************************/

/******************************************************************************\
                             Functions definitions
\******************************************************************************/

/*
*  : LED_On
*  : LED
*      : LEDID 
* ֵ   : NONE
*/
/******************************************************************************/
static void LED_On(uint8_t LedId)
/******************************************************************************/  
{
	switch(LedId)
	{
		case LED_R:
			LEDR_ON();
		break;
		
		case LED_G:
			LEDG_ON();
		break;

		default:
		break;
	}
}

/*
*  : LED_Off
*  : ϨLED
*      : LEDID
* ֵ   : NONE
*/
/******************************************************************************/
static void LED_Off(uint8_t LedId)
/******************************************************************************/  
{
	switch(LedId)
	{
		case LED_R:
			LEDR_OFF();
		break;
		
		case LED_G:
			LEDG_OFF();
		break;

		default: 
		break;
	}
}

#ifdef BREATHING_LIGHT

idata BRTH_LED_INFO BL_LED;

/*
*  : LED_Breathing_Light
*  : LED100usʱƬУÿ20msıһռձȡ
ģͺռ1.5s۵ͼʱ0.04s1/24֡棩
0.04s40ms20ms20msۿӦһֱ
ƣǸı40msУռõİٷְ١
1500/20=75ڣ40ms/75=266us75仯Уÿ1λ266us

75ڸպ40msܴﵽȫ֮ȫ
*      : NONE
* ֵ   : NONE
*/
/******************************************************************************/
void LED_Breathing_Light(void)
/******************************************************************************/
{
	uint8_t i;

	for(i = 0;i < LED_ID_MAX;i++)
	{
		if ( BL_LED.Breathing_Light_On[i] )
		{
			if( BL_LED.BL_Timer[i] <= BL_LED.BL_Flash_Duty[i] )   
			{
				LED_On(i);
			}
			else
			{
				LED_Off(i);
			}

			if( BL_LED.BL_Timer[i] >= BL_DUTY_MAX )
			{
				BL_LED.BL_Timer[i] = 0;
				
				if(BL_LED.Flash_Duty_Declining[i])
				{
					BL_LED.BL_Flash_Duty[i] -= BL_STEP;
				}
				else
				if(BL_LED.Flash_Duty_Rising[i])
				{
					BL_LED.BL_Flash_Duty[i] += BL_STEP;
				}				
			}

			if( BL_DUTY_MAX <= BL_LED.BL_Flash_Duty[i] )
			{
				BL_LED.Flash_Duty_Declining[i] = 1;
				BL_LED.Flash_Duty_Rising[i] = 0;
			}
			else
			if( BL_LED.BL_Flash_Duty[i] <= 1 )
			{
				BL_LED.Flash_Duty_Rising[i] = 1;
				BL_LED.Flash_Duty_Declining[i] = 0;
			}					
		}
				
		BL_LED.BL_Timer[i] += LED_PLUS_TIME;		
	}
}

#endif

#endif

