/*
 ******************************************************************************
 *
 * @file     main.c
 * @brief    main module
 *                 
 *
 * @version  1.0
 * @date     2022/07/12   17:35:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/07/12      Alex          build this file
 ******************************************************************************
 */
/*_____ I N C L U D E S ____________________________________________________*/
#include "define.h"
#include "userapp.h"
#include "watchdog.h"
#include "sys_tim.h"
#include "system.h"
#include "led.h"
#include "charger_module.h"
#include "adc.h"
#include "vox_module.h"


/******************************************************************************\
                          Macro definitions
\******************************************************************************/

/******************************************************************************\
                             Variables definitions
\******************************************************************************/
extern char code Version_Addr[3];



/******************************************************************************\
                             Functions definitions
\******************************************************************************/

void main(void )
{  
    System_Init();				//ϵͳʼ

#ifdef _DEBUG_MAIN		
	printf("System Init(Ver:%d%d%d)\r\n",Version_Addr[0],Version_Addr[1],Version_Addr[2]);

#endif	

    while(1)
    {
    
#if WTG_ENABLE    
		WDT = 1;
    	SWDT = 1;
#endif	
		Sys_Tim_Handler();			//ʱ		

		UserAPP();	
    }
}
