/*
 ******************************************************************************
 *
 * @file     sleep.c
 * @brief    sleep module
 *                 
 *
 * @version  1.0
 * @date     2023/03/22   17:35:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2023/03/22      Alex          build this file
 ******************************************************************************
 */
#include "sleep.h"
#include "system.h"
#include "vox_module.h"

#if SLEEP_ENABLE

/******************************************************************************\
                          Macro definitions
\******************************************************************************/

/******************************************************************************\
                             Variables definitions
\******************************************************************************/

uint8_t Decnt_SleepDelay = ENTER_STANDBYMODE_CNT;

bit Enter_Sleep_Cnt_Restart_Flag = 0;

/******************************************************************************\
                             Functions definitions
\******************************************************************************/


/*
 *******************************************************************************
 *             bool Check_Require_Sleep(void )
 *
 * Description : ѯ߻Դ־λ
 *
 * Arguments   : None

 * Returns     : None

 * Notes       : bool Flag
 *
 *******************************************************************************
 */
bit Check_Require_Sleep(void )
{	
	if( ( CHIP_STA4 & 0x80 ) || ( ON == Vox_Vout_Enable ) || Enter_Sleep_Cnt_Restart_Flag ) 		/*VBUS Power Goodڡжϡڳ״̬£Boostϵͳģʽ */	
	{
#ifdef _DEBUG_SLEEP
      	printf("Protect\r\n");
#endif	
		Enter_Sleep_Cnt_Restart_Flag = 0;
		/*Ӧıжϻ¼*/
		return false;
	}
	
    return true;   
}

#endif

