/*
 ******************************************************************************
 *
 * @file     VOX_Module.c
 * @brief    VOL/R module
 *                 
 *
 * @version  1.0
 * @date     2022/07/18   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/07/18      Alex          build this file
 ******************************************************************************
 */
#include "vox_module.h"
#include "led.h"
#include "system.h"
#include "discharge_module.h"
#include "sleep.h"
#include "bat.h"
#include "hall.h"
#include "key.h"
#include "sys_tim.h"
#include "adc.h"
#include "gpio_comm.h"
#include "userapp.h"
#include "key.h"

bit Vox_Vout_Enable = OFF;						//Vox־λ
bit Earphone_Chg_Flag = 0;						//б־λ
uint8_t Vox_TX_Timer = 0;						//VOXָʱ,Hall_Handler0.

#if VOX_ENABLE

/******************************************************************************\
                          Macro definitions
\******************************************************************************/
/*100ms*/
#define VOX_OUTPUT_SHORT_CNT		2
#define VOX_LOW_BAT_CNT				25					//ظǰӵ͵籣Vox 5V2.5s  	
#define VOX_VOUT_5V_LEAST_CNT		50	

#define VOX_VOUT_5V_DEBOUNCE		5					
#define VOX_ADT_HOLD_CNT			3
#define Vox_TX_Pattern_Cnt			3

#define BOOST_VOUT_MAX				2					//Boostѹֵ0:4.6V,1:4.7V,2:4.8V,3:5.05V.

#define Vox_TX_Pattern_Tim			10

#define Vox_TX_Interval				2  					//Voxʱָʱ

/******************************************************************************\
                             Variables definitions
\******************************************************************************/


uint8_t Vox_Vol_Hold_Timer = 0;

bit Cover_Close_Flag = 0;
bit Cover_Close_Flag1 = 0;

bit Cover_Open_Flag = 0;
bit Vox_Vout_5V_Flag = 0;

uint8_t Vox_Output_Debounce = 0;

bit Get_CHIP_STA1_Flag = 0;

bit Pattern_TX_Over_Flag = 0;

uint8_t CHIP_STA1_BK = 0;

bit Cover_Open_5V_Flag = 0;

#if VOX_FOLLOW_CHG

bit Boost_VoxVout_Follow_Flag = 0;
int8 Boost_Vout_Value = 0;
bit Boost_Up_Flag = 0;

#endif


/******************************************************************************\
                             Functions definitions
\******************************************************************************/

/*
  *******************************************************************************
  * 			void VOX_EN_Type(VOR_Enable_Type_e VOR_Enable_Type)
  *
  * Description : VOL Open(EN_VO)

  * Arguments	:
 
  * Returns 	:
 
  * Notes		:
  *
  *******************************************************************************
  */
 void VOX_EN_Type(VOX_Enable_Mode_e VOX_Enable_Mode)
 { 
 	COM_CTRL = ON;

	if( VOX_Enable_Mode == VOX_VOUT_Mode)
	{
		VOX_CTL0 &= ~0x30;		//VOX Disable 5V And Disable VOX ADT
		
		VOX_CTL0 |= 0x30;		//VOX Enable 5V    
	}
	else
	{
		VOX_CTL0 &= ~0x30;    //VOX 5v Off 	
	}
}
/*
*******************************************************************************
*			 void Vox_Det_Machine(void)
*
* Description : Vox Detect:ʶ (100ms)
*
* Arguments	 : NONE

* Returns	 : NONE

* Notes		 : NONE
*
*******************************************************************************
*/
void Vox_Det_Machine(void)
{
	/*Vox ֻÿ200msһ*/
	if( IRQ_FLAG0 & 0x0C )
	{		
		Vox_Output_Debounce++;
		if( Vox_Output_Debounce >= VOX_OUTPUT_SHORT_CNT )		//Vox·200ms¿Vox 5V
		{
			Vox_Output_Debounce = 0;
			IRQ_FLAG0 = 0x0C;
			VOX_EN_Type(VOX_VOUT_Mode);	
			return;
		}
	}	

	if( CoverEvent_Flg )								//Hall¼
	{	
		if( gBoost_Prepared_Flag )
		{				
			COM_CTRL = ON;
			
			if( !F_batlevel_low )                    //ѹ3.3VѹҪ߿ظ߼ڵЧʾ
			{
				if( !BST_EN )
				{			
					BST_EN = 1; 
					return;
				}	

				VOX_EN_Type(VOX_VOUT_Mode);		 		//VOX Enable 5VVOX˵NMOS			
			}
			
			if( CoverStatus == CLOSE )    				//1ظǹرCOM_CTRLʾЧѯLoadonIOFF״̬۶Ƿڲ֣Vox 5V
			{
#if VOX_FOLLOW_CHG
			
				if( BST_EN )
				{		
					/*߼*/
					SFRADDR = BST_CTL0;									//Boost 5V
					SFRDATA |= 0x03;
					Boost_Vout_Value = 0x03;
					Boost_Up_Flag = 0;
					
					SFRADDR = VOX_CON0;									//IOFFѡߵ10/15/20/25mA
					SFRDATA |= 0x20;	

					SFRADDR = VOX_CON2;									 
					SFRDATA &= ~0xC0;
					SFRDATA |= 0x80;									//IOFF 20mA		
				}	
				
#endif
			
				Cover_Close_Flag = 1;
								
				CoverEvent_Flg = 0;		
				
				Vox_Vout_Enable = ON;
				
				Cover_Open_Flag = 0;

				Vox_Vol_Hold_Timer = 0;					//ظ0ʹ
				
#if VOX_FOLLOW_CHG
				Boost_VoxVout_Follow_Flag = 1;
#endif				

			}
			else										//2Ǵ5v 500ms ת0V 500msתADTģʽ
			{			
				
				Cover_Close_Flag = 0;
				
				Vox_Vol_Hold_Timer = 0;
				
				Cover_Open_Flag = 1;

				Get_CHIP_STA1_Flag = 0;

				CoverEvent_Flg = 0;		

				Cover_Open_5V_Flag = 0;	

				Vox_Output_Debounce = 0;	

			}		
		} 
		else
		{			
			VOX_EN_Type(VOX_ADT_Mode);

			Vox_Vout_Enable = OFF;

			CoverEvent_Flg = 0;	
		}
	}

	/* Ϳָ*/
	if( Cover_Open_Flag )										/*Ǻ5V500ms0V500msVoxתadtģʽȴУʾӦĵЧ*/
	{
		if( Vox_Vol_Hold_Timer < VOX_VOUT_5V_DEBOUNCE )						//Ǻ5V 500ms
		{
			Vox_Vol_Hold_Timer++;
			
			return;
		}
		
		if( Vox_TX_Timer < VOX_VOUT_5V_DEBOUNCE )							//ת0V 500ms
		{
			COM_CTRL = OFF;

			BST_EN = 0;	
			
			Vox_TX_Timer++;

			Pattern_TX_Over_Flag = 1;
		}
		else
		{
			if( Pattern_TX_Over_Flag )                                 		//תadtģʽںʶּ
			{
				Pattern_TX_Over_Flag = 0; 
				
				COM_CTRL = ON;
				
				Vox_Vout_Enable = OFF;
				
				VOX_EN_Type(VOX_ADT_Mode);  
			}
			else
			{
				if( !Get_CHIP_STA1_Flag )
				{
					Get_CHIP_STA1_Flag = 1;
					
					CHIP_STA1_BK = CHIP_STA1 & 0xA0;						//ȡloadon״̬
				}
			}
			
			if( Get_CHIP_STA1_Flag )
			{
				/*ж*/
				if( CHIP_STA1_BK != (CHIP_STA1 & 0xA0) )					//ѯloadon״̬loadon״̬ı䣬˵жС
				{
					Earphone_Chg_Flag = 1;	

					Earphone_Chg_LED_On_Timer = 0;
					
					CHIP_STA1_BK = CHIP_STA1 & 0xA0;
				}
				
#if KEY_ENABLE
				/*״̬£5sVOXݣ55 AA 02 06 DD BA*/
				if( Key_Press_ll_irq )
				{	
					if( Vox_Output_Debounce < Vox_TX_Pattern_Tim )
					{
						if( (Vox_Output_Debounce % Vox_TX_Interval == 0) )
						{
							Vox_TX_Machine();
						}

						Vox_Output_Debounce++;
					}
					else
					{
						Key_Press_ll_irq = 0;
						
						Vox_Output_Debounce = 0;
					}
				}				
#endif				
			}
		}
	}
	
	if( Cover_Close_Flag )
	{			
		/*˵
		  1ظǺʼBoost5VIOFF 20mA
		*/
	#if VOX_FOLLOW_CHG
	
		if( Boost_VoxVout_Follow_Flag )
		{
			if ( CHIP_STA1 & 0x0C )					//ǷIOFF־ڣBoostһstepBoost½һstep
			{
				Boost_Vout_Value += 1;								//Boost һstep

				Boost_Up_Flag = 1;
				
				if( Boost_Vout_Value >= BOOST_VOUT_MAX )				//Boostﵽѹֵ䡣
				{
					Boost_Vout_Value = BOOST_VOUT_MAX;
					
					Boost_VoxVout_Follow_Flag = 0;
					
					SFRADDR = VOX_CON0;									//IOFFѡ͵2/3/4/5mA
					SFRDATA &= ~0x20;	

					SFRADDR = VOX_CON2;									 
					SFRDATA &= ~0xC0;
					SFRDATA |= 0x40;									//IOFF 3mA				
				}	
				
			}
			else
			{
				if( !Boost_Up_Flag )						//ֻڳʼصѹʱִ
				{
					Boost_Vout_Value -= 1;								//Boost ½һstep
					if( Boost_Vout_Value <= 0 )
					{
						Boost_Vout_Value = 0;
					}
				}
			}
			
			SFRADDR = BST_CTL0; 								//Boost 
			SFRDATA |= Boost_Vout_Value;

			return;
		}

		
	#endif
	
		if( ( (CHIP_STA1 & 0xAC) == 0xAC ) || F_batlevel_low )					//ӵ͵磬رVoutͨ·رBoost
		{			
			if( Vox_Vol_Hold_Timer < VOX_VOUT_5V_LEAST_CNT ) 					//תʱ5sرBoost
			{
				Vox_Vol_Hold_Timer++;
				
				return;
			}	
		
			BST_EN = 0; 			
					
			VOX_EN_Type(VOX_ADT_Mode);
			
			Vox_Vout_Enable = OFF;
			
			COM_CTRL = OFF;														//MOSܣʡġ
		}
	}	
}

#ifdef VOX_TX

/*
*******************************************************************************
*			 void Vox_TX_Machine(void)
*
* Description : Vor Detect:ʶ (100ms)
*
* Arguments	 : NONE

* Returns	 : NONE

* Notes		 : NONE
*
*******************************************************************************
*/

void Vox_TX_Machine(void)
{
	uint8_t tx_pData[7] = 0;
	
	tx_pData[0] = 0x55;
	
	tx_pData[1] = 0xAA;
	
	tx_pData[2] = 0x02;	
	
	tx_pData[3] = 0x06;
	
	tx_pData[4] = 0xDD;
	
	tx_pData[5] = 0xBA;
	
	COM_CTRL = OFF;					//VOXлͨѶTXģʽ3.3V
	
	SFRADDR = P0_PU;
	SFRDATA |= 0x02;

	SFRADDR = MFP_CTL0;
	SFRDATA |= 0x04;				//P01 as UART's TX

	Uart0SendPacket(7, tx_pData);		 //һֽڷͣҪTXΪGPIOᵼһֽûüȥ

	SFRADDR = MFP_CTL0;				//Set P01 Pinmux As GPIO Function
	SFRDATA &= ~0x0C;	
	
	SFRADDR = P0_PU;	
	SFRDATA &= ~0x02;	
	
	COM_CTRL = ON;	
}

#endif

#endif

